# over.py
import upygame as upg
import umachine
import urandom as random

obsOverPixels1 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x44\x44\x44\x44\
\x44\x44\x44\x44\
\x04\x44\x44\x40\
\x00\x44\x44\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels2 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x44\x44\x44\x44\
\x44\x40\x04\x44\
\x04\x40\x04\x40\
\x00\x44\x44\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels3 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x44\x44\x44\x44\
\x44\x00\x00\x44\
\x04\x40\x04\x40\
\x00\x44\x44\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels4 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x40\x04\x40\x04\
\x40\x00\x00\x04\
\x04\x00\x00\x40\
\x00\x40\x04\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels5 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x40\x04\x40\x04\
\x40\x00\x00\x04\
\x04\x00\x00\x40\
\x00\x40\x04\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels6 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x44\x44\x44\x44\
\x44\x00\x00\x44\
\x04\x40\x04\x40\
\x00\x44\x44\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

obsOverPixels7 = b'\
\x00\x00\x00\x00\
\x04\x40\x04\x40\
\x44\x44\x44\x44\
\x44\x40\x04\x44\
\x04\x40\x04\x40\
\x00\x44\x44\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
'

class Particle():
    def __init__(self):
        self.x = random.getrandbits(8)//2
        self.y = random.getrandbits(8)//2
        self.dx = (random.getrandbits(8) - 128) // 32
        self.dy = (random.getrandbits(8) - 128) // 32
        if(self.dx == 0):
            self.dx = 1
        if(self.dy == 0):
            self.dx = 1
        self.frame = random.getrandbits(8)
    
    def update(self,maxFrame):
        self.x +=self.dx
        self.y +=self.dy
        if(self.x > 110 or self.x < 0):
            self.dx = -self.dx
        if(self.y > 88 or self.y < 0):
            self.dy = -self.dy
        self.frame += 1
        if(self.frame>=maxFrame):
            self.frame = 0

    

class Over():
    def __init__(self):
        self.best = False
        self.sfs = (upg.surface.Surface(8, 8, obsOverPixels1),
                    upg.surface.Surface(8, 8, obsOverPixels2),
                    upg.surface.Surface(8, 8, obsOverPixels3),
                    upg.surface.Surface(8, 8, obsOverPixels4),
                    upg.surface.Surface(8, 8, obsOverPixels5),
                    upg.surface.Surface(8, 8, obsOverPixels6),
                    upg.surface.Surface(8, 8, obsOverPixels7),)
        self.particles = []
        for i in range(100):
            self.particles.append(Particle())
        #print("OVER")
        
    def Run(self,screen,gd):
        eventtype = upg.event.poll()
        if eventtype != upg.NOEVENT and eventtype.type== upg.KEYDOWN:
            gd.score = 0
            gd.speed = 3
            return True
        
        if (gd.score > gd.bestScore):
            self.best = True
            gd.bestScore = gd.score
            
        #particles
        if (self.best):
            for p in self.particles:
                p.update(len(self.sfs))
                screen.blit(self.sfs[p.frame],p.x,p.y) 
    
        #text
        umachine.draw_text(15,10,"GAME OVER",3)
        umachine.draw_text(15,30,"SCORE:" + str(gd.score),3)
        if (self.best):
            umachine.draw_text(4,50,"!HIGH SCORE!",5)
            
            
            
            